/*
 * Image plugin to VDR (C++)
 *
 * (C) 2003 Kai Tobias Burwieck <kai@burwieck.net>
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 */

#ifndef ___DATA_IMAGE_H
#define ___DATA_IMAGE_H

#include "data.h"

#include <vdr/thread.h>

// ----------------------------------------------------------------

extern cFileSources ImageSources;

class cFileSource;

// ----------------------------------------------------------------

class cImage:public cListObject {
  private:
    char *name, *fullname, *basename;
    cFileSource *source;
    //
    void Set(const char *Name);
    void Clear(void);
  public:
     cImage(const char *Name, cFileSource * Source);
    ~cImage();
    const char *Name(void) {
	return name;
    } const char *BaseName(void) {
	return basename;
    }
};

// ----------------------------------------------------------------

class cSlideShow:public cList < cImage >, public cListObject {
  private:
    //
    void Set(const char *Name);
    const char *AddExt(const char *Name, const char *Ext);
  protected:
    char *name, *basename, *fullname;
    cFileSource *source;
  public:
     cSlideShow(const char *Name, cFileSource * Source);
    ~cSlideShow();
//
    const char *Name(void) {
	return name;
    } const char *BaseName(void) {
	return basename;
    }
    const char *FullName(void) {
	return source->BuildName(fullname);
    }
};

// ----------------------------------------------------------------

class cISlideShow:public cScanDir, public cSlideShow {
  private:
    cDirItem item;
  protected:
    virtual void DoItem(cFileSource * src, const char *subdir,
			const char *name);
  public:
     cISlideShow(cDirItem * Item);
    virtual bool Load(void);
    virtual bool Save(void) {
	return false;
}};

// ----------------------------------------------------------------

class cSlideShows:public cScanDir, public cList < cSlideShow > {
  protected:
    virtual void DoItem(cFileSource * src, const char *subdir,
			const char *name);
  public:
     bool Load(cFileSource * Source);
};

#endif				//___DATA_IMAGE_H
