/*
 * Image plugin to VDR (C++)
 *
 * (C) 2003 Kai Tobias Burwieck <kai@burwieck.net>
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 */

#ifndef ___DVB_IMAGE_H
#define ___DVB_IMAGE_H

#include <vdr/player.h>
#include <vdr/thread.h>

class cImagePlayer;
class cSlideShow;

class cImagePlayerControl:public cControl {

  private:
    const char *FileName;
    cImagePlayer *player;
  public:
     time_t startime, convertime, t1, t2;
    bool ss, cstarted;
    const char *filename;
    int maxnum, aktnum, t3;

     cImagePlayerControl(cSlideShow * sshow);
     virtual ~ cImagePlayerControl();

    bool Active(void);
    void Stop(void);
    void Pause(void);
    void Play(void);

    void NextImage(int Step);
    void PrevImage(int Step);
    void GotoImage(int Pict);
    void RFlipImage(void);
    void LFlipImage(void);
    void OriginalImage(void);
    void Jump(void);
    int ImageCount(void);
    void IncSlideTime(void);
    void DecSlideTime(void);
    bool ConvertZoom(const char *filename, char *change, int xRes, int yRes,
		     int xPos, int yPos);
    bool ConvertJump(int Step);
};

#endif				//__DVB_IMAGE_H
